package com.heyang;

public class TreeOperation {
    /*
    Ľṹʾ
              1
            /   \
          2       3
         / \     / \
        4   5   6   7
    */

    // ڻĲ
    public static int getTreeDepth(Node node) {
        return node == null ? 0 : (1 + Math.max(getTreeDepth(node.getLeftChild()), getTreeDepth(node.getRightChild())));
    }


    private static void writeArray(Node currNode, int rowIndex, int columnIndex, String[][] res, int treeDepth) {
        // ֤Ϊ
        if (currNode == null) return;
        // Ƚǰڵ㱣浽ά
        res[rowIndex][columnIndex] = String.valueOf(currNode.getText());

        // 㵱ǰλĵڼ
        int currLevel = ((rowIndex + 1) / 2);
        // һ㣬򷵻
        if (currLevel == treeDepth) return;
        // 㵱ǰеһУÿԪ֮ļһе뵱ǰԪص֮ļ
        int gap = treeDepth - currLevel - 1;

        // ӽжϣӣ¼Ӧ"/"ӵֵ
        if (currNode.getLeftChild() != null) {
            res[rowIndex + 1][columnIndex - gap] = "/";
            writeArray(currNode.getLeftChild(), rowIndex + 2, columnIndex - gap * 2, res, treeDepth);
        }

        // ҶӽжϣҶӣ¼Ӧ"\"Ҷӵֵ
        if (currNode.getRightChild() != null) {
            res[rowIndex + 1][columnIndex + gap] = "\\";
            writeArray(currNode.getRightChild(), rowIndex + 2, columnIndex + gap * 2, res, treeDepth);
        }
    }


    public static void show(Node root) {
        if (root == null) System.out.println("EMPTY!");
        // õ
        int treeDepth = getTreeDepth(root);
        //System.out.println("treeDepth="+treeDepth);

        // һеĿΪ2ģn - 1η3ټ1
        // ΪάĿ
        int arrayHeight = treeDepth * 2 - 1;
        int arrayWidth = (2 << (treeDepth - 2)) * 3 + 1;
        // һַ洢ÿλӦʾԪ
        String[][] res = new String[arrayHeight][arrayWidth];
        // гʼĬΪһո
        for (int i = 0; i < arrayHeight; i ++) {
            for (int j = 0; j < arrayWidth; j ++) {
                res[i][j] = " ";
            }
        }

        // Ӹڵ㿪ʼݹ鴦
        // res[0][(arrayWidth + 1)/ 2] = (char)(root.val + '0');
        writeArray(root, 0, arrayWidth/ 2, res, treeDepth);

        // ʱѾҪʾԪش浽˶άУƴӲӡ
        for (String[] line: res) {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < line.length; i ++) {
                sb.append(line[i]);
                if (line[i].length() > 1 && i <= line.length - 1) {
                    i += line[i].length() > 4 ? 2: line[i].length() - 1;
                }
            }
            System.out.println(sb.toString());
        }
    }
}
